您的位置:首页 > 其它

Function Run Fun (HDU 1331) —— 记忆化搜索DP

2014-08-22 22:14 399 查看

Function Run Fun

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 2188 Accepted Submission(s): 1112



Problem Description
We all love recursion! Don't we?

Consider a three-parameter recursive function w(a, b, c):

if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:

1

if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:

w(20, 20, 20)

if a < b and b < c, then w(a, b, c) returns:

w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)

otherwise it returns:

w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)

This is an easy function to implement. The problem is, if implemented directly, for moderate values of a, b and c (for example, a = 15, b = 15, c = 15), the program takes hours to run because of the massive recursion.

Input
The input for your program will be a series of integer triples, one per line, until the end-of-file flag of -1 -1 -1. Using the above technique, you are to calculate w(a, b, c) efficiently and print the result.

Output
Print the value for w(a,b,c) for each triple.

Sample Input
1 1 1
2 2 2
10 4 6
50 50 50
-1 7 18
-1 -1 -1


Sample Output
w(1, 1, 1) = 2
w(2, 2, 2) = 4
w(10, 4, 6) = 523
w(50, 50, 50) = 1048576
w(-1, 7, 18) = 1


Source
Pacific Northwest 1999

题意:根据题目所给的递归方程求解相应值。

由于递归的方式会导致有大量重复的计算,所以此时可以采用记忆化搜索的方式,用数组保存计算过的值,当再次调用它时可直接返回储存的值。
#include<stdio.h>
#include<string.h>
int dp[30][30][30]; //利用三维数组存储数据
int w(int a, int b, int c)
{
    if(a <= 0 || b <= 0 || c <= 0) return 1;
    if(a > 20 || b > 20 || c > 20) return 1048576; 
    if(dp[a][b][c] != 0) return dp[a][b][c]; //当出现已计算过的值时直接返回所储存的值
    if(a < b && b < c)
        return dp[a][b][c] = w(a,b,c-1)+w(a,b-1,c-1)-w(a,b-1,c); //利用赋值语句存储,方便下次调用
    else
        return dp[a][b][c] = w(a-1,b,c)+w(a-1,b-1,c)+w(a-1,b,c-1)-w(a-1,b-1,c-1);
}
int main()
{
    int a, b, c;

    while(~scanf("%d%d%d", &a,&b,&c))
    {
        if(a == -1 && b == -1 && c == -1) break;
        memset(dp, 0, sizeof(dp)); //初始化
        printf("w(%d, %d, %d) = %d\n", a,b,c,w(a,b,c));
    }
    return 0;
}


由于递归的最后总会有返回值,所以我们也可以通过枚举所有情况反向求解所有相应值,利用三维数组存储结果。
#include<stdio.h>
int main()
{
    int a, b, c, i, j, k, w[30][30][30];

    for(i=0; i<=20; i++)
    {
        for(j=0; j<=20; j++)
        {
            for(k=0; k<=20; k++)
            {
                if(i == 0 || j == 0 || k == 0) w[i][j][k] = 1;
                else if(i < j && j < k) w[i][j][k] = w[i][j][k-1]+w[i][j-1][k-1]-w[i][j-1][k];
                else w[i][j][k] = w[i-1][j][k]+w[i-1][j-1][k]+w[i-1][j][k-1]-w[i-1][j-1][k-1];
            }
        }
    }
    while(~scanf("%d%d%d", &a,&b,&c))
    {
        if(a == -1 && b == -1 && c == -1) break;
        int temp;
        if(a <= 0 || b <= 0 || c <= 0) temp = 1;
        else if(a > 20 || b > 20 || c > 20) temp = w[20][20][20];
        else temp = w[a][b][c];
        printf("w(%d, %d, %d) = %d\n", a,b,c,temp);
    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: